<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\AnswerRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\Question;
use App\TrainReservation;
use App\Reservation;
use App\SystemPhysic;
use App\Answer;
use App\TrainnerReservation;
use App\DoctorReservation;
use App\SystemFood;

class PatientPhysicalReservationController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/patientphysicalreservations';
    /** View folder */
    private $viewDirectory= 'admin.patientphysicalreservations.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('patientphysicalreservations.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the patientphysicalreservations.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $user = \Auth::user();
        $query = TrainReservation::where('patient_id',$user->id)->where('trainner_id','!=',NULL)->where('dating','!=',NULL)->where('expired','0')->orderBy('id', 'DESC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->answer) {
            $query->where('answer', 'LIKE', '%'.$request->answer.'%');
        }
        if ($request->patient) {
            $query->whereIn('user_id', patient($request->patient));
        }
        if ($request->question) {
            $query->whereIn('question_id', question($request->question));
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $patientphysicalreservations= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('patientphysicalreservations'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('patientphysicalreservations.store');
        $head = metaFields('patientphysicalreservations', 'add_new', getCurrentLocale()) ?? __('patientphysicalreservations.new');
        $questions = Question::cursor();
        $patients = User::where('role_id','6')->get();
       

        return view( $this->viewDirectory.'form', compact('action','questions', 'head','patients') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param AnswerRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(AnswerRequest $request) :RedirectResponse
    {
        
        $answer= Answer::create($request->all());
       
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  Answer  $answer
     * @return View
     */
    public function edit(TrainReservation $patientphysicalreservation): View
    {
        
        $action= route('trainnerreservations.update', $patientphysicalreservation->id);
        $head = metaFields('trainnerreservations', 'new', getCurrentLocale()) ?? __('trainnerreservations.new');
        $reservation = $patientphysicalreservation;   
        $systemphysics = SystemPhysic::cursor();
        $patient = User::find($patientphysicalreservation->patient_id);
        $reserved = TrainnerReservation::where('physical_reservation_id',$patientphysicalreservation->id)->count();
        $reservations = TrainnerReservation::where('physical_reservation_id',$patientphysicalreservation->id)->get();
        
        $answers = Answer::where('user_id',$patientphysicalreservation->patient_id)->get();
        $last = TrainnerReservation::where('physical_reservation_id',$patientphysicalreservation->id)->where('system_physic_id','!=',NULL)->orderBy('id','DESC')->first();
       $reserved_ids = Reservation::where('patient_id',$patientphysicalreservation->patient_id)->pluck('id');
       $systemfood_ids = DoctorReservation::whereIn('doctor_reservation_id',$reserved_ids)->pluck('system_food_id');
       $systemfoods = SystemFood::find($systemfood_ids);
       $systemphysic = SystemPhysic::find($patientphysicalreservation->system_physic_id);

        return view( $this->viewDirectory.'form', compact('reservation', 'action', 'head','systemphysics','systemfoods','reservations','patient','reserved','answers','last','systemphysic') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  AnswerRequest  $request
     * @param  Answer  $systemfood
     * @return RedirectResponse|Redirector
     */
        public function update(AnswerRequest $request, Answer $answer) :RedirectResponse
    {
        
        $answer->update($request->all());

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = Answer::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Answer::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Answer::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = Answer::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = Answer::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
